CodeForces 292D Connected Components(变种并查集+预处理)

来源:互联网 发布:海信淘宝旗舰店 编辑:程序博客网 时间:2024/05/21 11:22

We already know of the large corporation where Polycarpus works as a system administrator. The computer network there consists of n computers and m cables that connect some pairs of computers. In other words, the computer network can be represented as some non-directed graph with n nodes and m edges. Let's index the computers with integers from 1 to n, let's index the cables with integers from 1 to m.

Polycarpus was given an important task — check the reliability of his company's network. For that Polycarpus decided to carry out a series of k experiments on the computer network, where the i-th experiment goes as follows:

  1. Temporarily disconnect the cables with indexes from li to ri, inclusive (the other cables remain connected).
  2. Count the number of connected components in the graph that is defining the computer network at that moment.
  3. Re-connect the disconnected cables with indexes from li to ri (that is, restore the initial network).

Help Polycarpus carry out all experiments and for each print the number of connected components in the graph that defines the computer network through the given experiment. Isolated vertex should be counted as single component.

Input

The first line contains two space-separated integers nm (2 ≤ n ≤ 500; 1 ≤ m ≤ 104)— the number of computers and the number of cables, correspondingly.

The following m lines contain the cables' description. The i-th line contains space-separated pair of integers xiyi (1 ≤ xi, yi ≤ nxi ≠ yi) — the numbers of the computers that are connected by the i-th cable. Note that a pair of computers can be connected by multiple cables.

The next line contains integer k (1 ≤ k ≤ 2·104) — the number of experiments. Next k lines contain the experiments' descriptions. The i-th line contains space-separated integers liri (1 ≤ li ≤ ri ≤ m) — the numbers of the cables that Polycarpus disconnects during the i-th experiment.

Output

Print k numbers, the i-th number represents the number of connected components of the graph that defines the computer network during the i-th experiment.

Example
Input
6 51 25 42 33 13 661 32 51 55 52 43 3
Output
456342

题解:

题意:

给你一张节点数为n的图,然后给m条边的情况,然后是s组询问,问你去掉[l,r]范围内的边最后可以形成多少个连通块

思路:

一开始用dfs暴力写,华丽地tle了,然后想到了并查集,然后又暴力写,又是tle,冷静下来以后发现每次都求一遍并查集很浪费时间,然后就想到了预处理一遍,因为每次都是除去[l,r]后的情况,那么就可以先预处理一遍加入了[1,l-1]的边的情况和加入了[r+1,m]的边的情况,然后合并这两个集合就可以了,然后就枚举这些情况保存下来备用

代码:

#include<iostream>#include<cstring>#include<stdio.h>#include<math.h>#include<string>#include<stdio.h>#include<queue>#include<stack>#include<map>#include<vector>#include<deque>#include<algorithm>#define ll long long#define INF 1008611111#define M (t[k].l+t[k].r)/2#define lson k*2#define rson k*2+1using namespace std;struct edge{    int f,t;}a[10005];int prel[10005][505];int prer[10005][505];int ppre[505];int find(int pre[],int x){    if(pre[x]!=x)        pre[x]=find(pre,pre[x]);    return pre[x];}int l,r;int main(){    int i,j,n,m,x,y,s,d1,d2;    scanf("%d%d",&n,&m);    for(i=1;i<=m;i++)    {        scanf("%d%d",&x,&y);        a[i].f=x;        a[i].t=y;    }    for(j=1;j<=n;j++)    {        prel[0][j]=j;    }    for(i=1;i<=m;i++)    {        for(j=1;j<=n;j++)        {            prel[i][j]=prel[i-1][j];        }        d1=find(prel[i],a[i].f);        d2=find(prel[i],a[i].t);        if(d1!=d2)        {            prel[i][d2]=d1;        }    }    for(j=1;j<=n;j++)    {        prer[m+1][j]=j;    }    for(i=m;i>=1;i--)    {        for(j=1;j<=n;j++)        {            prer[i][j]=prer[i+1][j];        }        d1=find(prer[i],a[i].f);        d2=find(prer[i],a[i].t);        if(d1!=d2)        {            prer[i][d2]=d1;        }    }    scanf("%d",&s);    while(s--)    {        scanf("%d%d",&l,&r);        int ans=0;        if(l>r)            swap(l,r);        for(i=1;i<=n;i++)        {            ppre[i]=prel[l-1][i];            //printf("prel[%d]=%d!!\n",i,ppre[i]);        }        for(i=1;i<=n;i++)        {            d1=find(ppre,i);            d2=find(prer[r+1],i);            d2=find(ppre,d2);            //printf("prer[%d]=%d!!\n",i,d2);            if(d1!=d2)            {                ppre[d2]=d1;            }        }        for(i=1;i<=n;i++)        {            if(ppre[i]==i)                ans++;        }        printf("%d\n",ans);    }    return 0;}



阅读全文
0 0